import QtQuick 2.15
import QtQuick.Controls 2.15

ApplicationWindow {
    width: 640
    height: 480
    visible: true
    title: qsTr("Scroll")


    function getQmlType(_object) {
        return _object.toString().split('_')[0]
    }

    function accessibleName(_context, _id) {
        if (!_context || (typeof _context) !== "undefined")
            return ""
        var name = _context
        if (!_id || (typeof _id) !== "undefined")
            name += "_" + _id

        var _index, _text
        if (typeof arguments[2] === "number") {
            _index = arguments[2]
            if (typeof arguments[3] === "string")
                _text = arguments[3]
        }
        else if (typeof arguments[2] === "string")
            _text = arguments[2]

        if (defined(_index)) {
            if (_index < 0)
                return ""
            name += "_" + _index
        }
        if (defined(_text))
            name += "@" + _text
        return name
    }

    ScrollView {
        anchors.fill: parent



        ListView {
            id: listView
            width: parent.width


            model: listModel
            delegate: ItemDelegate {
                id: baseItemDelegate
                text: modelData
                Accessible.focusable: true
                Accessible.description: "Delegate"

                width: listView.width
                property string accessibleContext: getQmlType(baseItemDelegate)

                contentItem: Label {
                    id: primaryLabel
                    text: baseItemDelegate.text
                    property string accessibleContext: accessibleName(baseItemDelegate.accessibleContext, "primaryLabel")
                    Accessible.description: "Content"
                    Accessible.role: Accessible.StaticText
                    Accessible.name: accessibleContext ? accessibleContext + "@" + text : ""
                }
            }
        }
    }
}
